/* ====================================================================
 *
 * WinHcs
 * Copyright (c) 1997-1999. Philippe Printz.		All rights reserved.
 *
 *	The WinHcs software is OSI Certified Open Source Software.
 *	OSI Certified is a certification mark of the Open Source Initiative.
 *
 *	WinHcs maybe distributed under the terms of the	GNU General Public License.
 *
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by Philippe Printz
 *    for use in the HCS project."
 *
 * 4. The names "WinHcs" and "HCS" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission.
 *
 * 5. Products derived from this software may not be called "WinHcs"
 *    nor may "WinHcs" appear in their names without prior written
 *    permission of the WinHcs.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Philippe Printz
 *    for use in the HCS project."
 *
 * THIS SOFTWARE IS PROVIDED BY PHILIPPE PRINTZ ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL PHILIPPE PRINTZ OR
 * OTHER CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals and was originally based on software written by
 * Philippe C. Printz.
 *
 */

// DlgRunMacro.cpp : implementation file
//

#include "stdafx.h"
#include "WinHcs.h"
#include "DlgRunMacro.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgRunMacro dialog


CDlgRunMacro::CDlgRunMacro(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRunMacro::IDD, pParent)
{
	CWinHcsApp	*pApp = (CWinHcsApp *) AfxGetApp();

	//{{AFX_DATA_INIT(CDlgRunMacro)
	m_exec = pApp->GetProfileCString(IDS_REG_MACRO, IDS_REG_LAST_MACRO, _T(""));
	//}}AFX_DATA_INIT

	m_pVbModule = NULL;
}


void CDlgRunMacro::DoDataExchange(CDataExchange* pDX)
{
	CWinHcsApp	*pApp = (CWinHcsApp *) AfxGetApp();

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CDlgRunMacro)
	DDX_CBString(pDX, IDC_COMBO, m_exec);
	//}}AFX_DATA_MAP

	pApp->SetProfileCString(IDS_REG_MACRO, IDS_REG_LAST_MACRO, m_exec);
}


BEGIN_MESSAGE_MAP(CDlgRunMacro, CDialog)
	//{{AFX_MSG_MAP(CDlgRunMacro)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRunMacro message handlers

BOOL CDlgRunMacro::OnInitDialog() 
{
	CComboBox					*pBox;

	pBox = (CComboBox *) GetDlgItem(IDC_COMBO);
	pBox->ResetContent();
	
	CDialog::OnInitDialog();

	if (m_pVbModule != NULL) {

		CString						procName;
		CScriptProcedureCollection	procedures;
		CScriptProcedure			procedure;
		long						i, n, p;
		VARIANT						vt;

		procedures  = m_pVbModule->GetProcedures();
		n			= procedures.GetCount();

		for (i = 0 ; i < n ; i++) {

			vt.vt = VT_I4;
			vt.lVal = i + 1;	

			procedure = procedures.GetItem(vt);
			procName = procedure.GetName ();

			p = pBox->AddString(procName);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
