/* ====================================================================
 *
 * WinHcs
 * Copyright (c) 1997-1999. Philippe Printz.		All rights reserved.
 *
 *	The WinHcs software is OSI Certified Open Source Software.
 *	OSI Certified is a certification mark of the Open Source Initiative.
 *
 *	WinHcs maybe distributed under the terms of the	GNU General Public License.
 *
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by Philippe Printz
 *    for use in the HCS project."
 *
 * 4. The names "WinHcs" and "HCS" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission.
 *
 * 5. Products derived from this software may not be called "WinHcs"
 *    nor may "WinHcs" appear in their names without prior written
 *    permission of the WinHcs.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Philippe Printz
 *    for use in the HCS project."
 *
 * THIS SOFTWARE IS PROVIDED BY PHILIPPE PRINTZ ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL PHILIPPE PRINTZ OR
 * OTHER CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals and was originally based on software written by
 * Philippe C. Printz.
 *
 */

//{{AFX_INCLUDES()
#include "msflexgrid.h"
#include "scriptcontrol.h"
#include "mschart.h"
//}}AFX_INCLUDES
#if !defined(AFX_LOGSHEET_H__52575326_544D_11D3_B8A7_0000861E056C__INCLUDED_)
#define AFX_LOGSHEET_H__52575326_544D_11D3_B8A7_0000861E056C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CLogChartPage dialog

class CLogChartPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CLogChartPage)

// Construction
public:
	CLogChartPage();
	~CLogChartPage();

// Dialog Data
	//{{AFX_DATA(CLogChartPage)
	enum { IDD = IDD_LOG_CHART };
	CMSChart m_chartControl;
	CString	m_dateFrom;
	CString	m_dateTo;
	CString	m_expression;
	CString	m_logID1;
	CString	m_logID2;
	//}}AFX_DATA

	BOOL m_dataFromHcs;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CLogChartPage)
	public:
	virtual void OnFinalRelease();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CLogChartPage)
	afx_msg void OnButtonRefresh();
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonUpload();
	afx_msg void OnChartRadioDb();
	afx_msg void OnChartRadioHcs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CLogTablePage dialog

class CLogTablePage : public CPropertyPage
{
	DECLARE_DYNCREATE(CLogTablePage)

// Construction
public:
	CLogTablePage();
	~CLogTablePage();

// Dialog Data
	//{{AFX_DATA(CLogTablePage)
	enum { IDD = IDD_LOG_TABLE };
	CMSFlexGrid	m_gridControl;
	CString	m_expression;
	CString	m_dateFrom;
	CString	m_dateTo;
	CString	m_logIDFrom;
	CString	m_logIDTo;
	//}}AFX_DATA

	BOOL m_dataFromHcs;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CLogTablePage)
	public:
	virtual void OnFinalRelease();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CLogTablePage)
	afx_msg void OnButtonRefresh();
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonUpload();
	afx_msg void OnTableRadioDb();
	afx_msg void OnTableRadioHcs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CLogSheet

class CLogSheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CLogSheet)

// Construction
public:
	CLogSheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CLogSheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLogSheet)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CLogSheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(CLogSheet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOGSHEET_H__52575326_544D_11D3_B8A7_0000861E056C__INCLUDED_)


